require('lib/Serial/Tserial')
Binaryan = false

textureFolder = "texturepacks/Opengameart/"

mainMenu = {}
mainMenu[1] = {}
mainMenu[1].name = "Start new world"
mainMenu[1].action = "new"
mainMenu[2] = {}
mainMenu[2].name = "Load Game"
mainMenu[2].action = "load"
mainMenu[3] = {}
mainMenu[3].name = "Texturepacks"
mainMenu[3].action = "texture"
mainMenu[4] = {}
mainMenu[4].name = "Customize Player"
mainMenu[4].action = "player"
mainMenu[5] = {}
mainMenu[5].name = "Credits"
mainMenu[5].action = "credits"
mainMenu[6] = {}
mainMenu[6].name = "Quit"
mainMenu[6].action = "quit"

creditMenu = {}
creditMenu[1] = {}
creditMenu[1].name = "Binaryan Orkandyke / VividReality"
creditMenu[2] = {}
creditMenu[2].name = "Brogrammer, Grafixdoodler, Codewanker."
creditMenu[3] = {}
creditMenu[3].name = "-+-+-+-+-"
creditMenu[4] = {}
creditMenu[4].name = "Solsforest"
creditMenu[5] = {}
creditMenu[5].name = "Support, #1 Alphatester, Graphics."
creditMenu[6] = {}
creditMenu[6].name = "-+-+-+-+-"
creditMenu[7] = {}
creditMenu[7].name = "Josefnpat"
creditMenu[8] = {}
creditMenu[8].name = "Putting up with me and my codewankery."
creditMenu[9] = {}
creditMenu[9].name = "-+-+-+-+-"
creditMenu[10] = {}
creditMenu[10].name = "Moorks"
creditMenu[11] = {}
creditMenu[11].name = "Support, being a cool dude in general."
creditMenu[12] = {}
creditMenu[12].name = "-+-+-+-+-"
creditMenu[13] = {}
creditMenu[13].name = "Pix3M (Deviantart)"
creditMenu[14] = {}
creditMenu[14].name = "Font."
creditMenu[15] = {}
creditMenu[15].name = "-+-+-+-+-"
creditMenu[16] = {}
creditMenu[16].name = "Lanea Zimmerman & Jerom from opengameart.org"
creditMenu[17] = {}
creditMenu[17].name = "creators of the graphics used in the opengameart texturepack."
creditMenu[18] = {}
creditMenu[18].name = "(CC-BY-SA 3.0)"
creditMenu[19] = {}
creditMenu[19].name = "back"
creditMenu[19].action = "back"

currentMenu = mainMenu

mainMenuSelection = 1

function mainMenu.keyPressed(key)
	if key == "up" then
		mainMenuSelection = mainMenuSelection - 1
	elseif key == "down" then
		mainMenuSelection = mainMenuSelection + 1
	elseif key == "return" then
		mainMenu.act(currentMenu[mainMenuSelection].action,currentMenu[mainMenuSelection].args or false)
	end
	if mainMenuSelection < 1 then mainMenuSelection = #currentMenu end
	if mainMenuSelection > #currentMenu then mainMenuSelection = 1 end
end

--local compressedSerializedTable = compress( serialize( myTable ) )
--local decompressedSerializedTable = decompress( compressedSerializedTable )
--local deserializedTable = deserialize( decompress( decompressedSerializedTable ) )

function saveGame(savingStep)
StatusMessage = "Saving..."
if savingStep == 1 then
SaveFile = {}
SaveFile.chunk = Chunk
elseif savingStep == 2 then
SaveFile.minute = minute
SaveFile.tiles = World
elseif savingStep == 3 then
SaveFile.agriculture = agriculture
elseif savingStep == 4 then
SaveFile.items = itemContainer
elseif savingStep == 5 then
SaveFile.animals = SpawnedAnimals
elseif savingStep == 6 then
SaveFile.discovered = Discovered
elseif savingStep == 7 then
--SaveFile.CollisionLayer = CollisionLayer
SaveFile.player = player or love.graphics.newImage(textureFolder .. "player.png")
elseif savingStep == 8 then
local SerializedTable = Tserial.pack(SaveFile,true,true)
love.filesystem.write(save_prefix .. os.time() .. ".sav", SerializedTable)
StatusMessage = "Writing savegame..."
elseif savingStep == 9 then
StatusMessage = "Game saved!"
saving = false
end
end

save_prefix = "save_"

function save_list()
local files = love.filesystem.enumerate(".")
local saves = {}
for i,v in pairs(files) do
if string.sub(v,1,string.len(save_prefix)) == save_prefix then
table.insert(saves,v)
end
end
return saves
end

function loadGame(saveFilePath)
print("loading")
local contents = love.filesystem.read(saveFilePath)
print("savefile found, going to read...")
local saveFile = Tserial.unpack(contents,true)
if saveFile then
print("done reading, going to set the game...")
loadTiles()
loadItems()
loadBlueprints()
loadAnimals()
World = saveFile.tiles
agriculture = saveFile.agriculture
itemContainer = saveFile.items
SpawnedAnimals = saveFile.animals
--CollisionLayer = saveFile.CollisionLayer
for i = 1, #SpawnedAnimals do
SpawnedAnimals[i].img = animals[SpawnedAnimals[i].ID].img
end
Discovered = saveFile.discovered
minute = saveFile.minute
Chunk = saveFile.chunk
cursorImg = love.graphics.newImage(textureFolder .. "cursor.png")
love.graphics.setLineWidth(1)
player_load()
Map = love.graphics.newCanvas(#World,#World[1])
MapGenerated = false
player = saveFile.player
selectedTile = {}
selectedTile[1] = player.x
selectedTile[2] = player.y
if not playerCustomImage then playerCustomImage = textureFolder .. "player.png" end
player.img = love.graphics.newImage(playerCustomImage)
tileHeight = player.img:getHeight()
tileWidth = player.img:getWidth()
camera.width = math.ceil(800 / tileWidth)
camera.height = math.ceil(500 / tileHeight)
playerSprite = player.img
print("game set, attempting to start game...")
newWorld = false
ingame = true
mainMenuScreen = false
gameover = false
setLevel(World)
print("game started.")
else
print("failure.")
end
end

function showSaves()
savefileList = save_list()
	saveMenu = {}
	for i = 1, #savefileList do	
saveMenu[i] = {}
newString = string.gsub(savefileList[i],save_prefix,"")
newString = string.gsub(savefileList[i],".sav","")
newNumber = string.match(newString, '%d+')
saveMenu[i].name = os.date("%H:%M %d/%m/%y",newNumber)
saveMenu[i].action = "continue"
saveMenu[i].args = savefileList[i]
	end
saveMenu[#saveMenu + 1] = {}
saveMenu[#saveMenu].name = "Back"
saveMenu[#saveMenu].action = "back"
end

function texturePacks()

files = love.filesystem.enumerate("texturepacks/")
	texturePackMenu = {}
	for i = 1, #files do
		texturePackMenu[i] = {}
		texturePackMenu[i].name = files[i]
		texturePackMenu[i].action = "pack"
		texturePackMenu[i].args = "texturepacks/" .. files[i] .. "/"
	end
end

function getPlayerImages(path)
	files = love.filesystem.enumerate(path)
	playerMenu = {}
	for i = 1, #files do
			if string.sub(files[i],1,string.len("player")) == "player" then
		playerMenu[#playerMenu + 1] = {}
		playerMenu[#playerMenu].name = files[i]
		playerMenu[#playerMenu].img = love.graphics.newImage(path .. files[i])
		playerMenu[#playerMenu].action = "playerTexture"
		playerMenu[#playerMenu].args = path .. files[i]
		print(path .. files[i])
			end
	end
end

function mainMenu.act(action,args)
	if action == "new" then
		newWorld = true
		loading = true
		mainMenuScreen = false
		LoadingText = "Loading Assets"
	elseif action == "load" then
		showSaves()
		currentMenu = saveMenu
	elseif action == "credits" then
		currentMenu = creditMenu
		Binaryan = true
	elseif action == "texture" then
		texturePacks()
		currentMenu = texturePackMenu
	elseif action ==  "player" then
		getPlayerImages(textureFolder)
		currentMenu = playerMenu
	elseif action ==  "playerTexture" then
		playerCustomImage = args
		currentMenu = mainMenu
	elseif action == "pack" then
		textureFolder = args	
		currentMenu = mainMenu
	elseif action == "quit" then
	elseif action == "continue" then
		loadGame(args)
	elseif action == "back" then
		currentMenu = mainMenu
		Binaryan = false
	end
end