Chunk = {}
ChunkWidth = 128
ChunkHeight = 128
WorldHeight = 100
MinTemperature = -30
MaxTemperature = 40
camera = {0,0}
World = {}

function GenerateWorld(tiles)
Chunk = {0,0}
Chunk = InitializeWorld(WorldHeight,8)
Chunk = Pass(Chunk,80)
Chunk = Pass(Chunk,40)
Chunk = Pass(Chunk,20)
Chunk = Pass(Chunk,10)
Chunk = Pass(Chunk,1)
Chunk = Pass(Chunk,0)
Chunk = Pass(Chunk,0)
Chunk = absChunk(Chunk)
Chunk = RoundOffChunk(Chunk)
CheckProbabilityAndSetWorld(tiles)
end

function GenerateBiomes()
Chunk = {0,0}
Chunk = InitializeWorld(MaxTemperature - MinTemperature,8)
Chunk = Pass(Chunk,20)
Chunk = Pass(Chunk,10)
Chunk = Pass(Chunk,0)
Chunk = Pass(Chunk,0)
Chunk = Pass(Chunk,0)
Chunk = Pass(Chunk,1)
Chunk = Pass(Chunk,0)
Biomes = {}
for x = 1, #Chunk do
		Biomes[x] = {}
		for y = 1, #Chunk[1] do
			Biomes[x][y] = Chunk[x][y] - 20
		end
end
end

function CheckProbabilityAndSetWorld(tiles)
LastScore = 9999999
BestProbability = 3
CollisionLayer = {}
agriculture = {}
itemContainer = {}
	for x = 1, #Chunk do 
		World[x] = {}
		itemContainer[x] = {}
		CollisionLayer[x] = {}
		agriculture[x] = {}
		for y = 1, #Chunk[1] do
			CollisionLayer[x][y] = 1
			itemContainer[x][y] = false
			for n = 1, #tiles do
				if not tiles[n].artificial then
				HeightScore 		=  math.abs(Chunk[x][y] - tiles[n].PreferredHeight)
				TemperatureScore 	=  math.abs(Biomes[x][y] - tiles[n].PreferredTemperature)
				CurrentScore = HeightScore + TemperatureScore
				if CurrentScore < LastScore and math.random(tiles[n].rarity) == 1  then
					BestProbability = n
					LastScore = CurrentScore
				end
				end
			end
			--Best Probability has probably been found, so set tile.
			World[x][y] = BestProbability
			if tiles[World[x][y]].walkable == false then
						CollisionLayer[x][y] = 2
			end
			
			if tiles[World[x][y]].container then
				itemContainer[x][y] = {}
				itemContainer[x][y].items = {}
				lootAmount = math.random(10)
				for i = 1, lootAmount do
					itemContainer[x][y].items[i] = math.random(#blueprints)
				end
			end
			if tiles[World[x][y]].timeBloom then
				agriculture[x][y] = -math.random(tiles[World[x][y]].timeBloom)
			end
			LastScore = 9999999
		end
	end
end



function RoundOffChunk(OldChunk)
NewChunk = {}
for x = 1, #OldChunk do
	NewChunk[x] = {}
		for y = 1, #OldChunk[1] do
		if OldChunk[x][y] > WorldHeight then OldChunk[x][y] = WorldHeight end
		if OldChunk[x][y] < 1 then OldChunk[x][y] = 1 end
		
		newX =  (WorldHeight / #OldChunk * x) - WorldHeight / 2
		newY = 	(WorldHeight / #OldChunk[1] * y) - WorldHeight / 2
		local offset = (math.abs(newX - newY) + math.abs(newX + newY)) * 1.5 
		NewChunk[x][y] = OldChunk[x][y] - offset + WorldHeight / 2
		end
	end
return NewChunk
end

function InitializeWorld(Height, Size)
NewChunk = {}
for x = 1, Size do
	NewChunk[x] = {}
	for y = 1, Size do
		NewChunk[x][y] = math.random(Height)
	end
end

return NewChunk
end

function absChunk(OldChunk)
GoalWidth = #OldChunk * 2
GoalHeight = #OldChunk[1] * 2

NewChunk = {}
for x = 1, #OldChunk do
	NewChunk[x] = {}
	for y = 1, #OldChunk[1] do
		NewChunk[x][y] = math.abs(OldChunk[x][y] - (WorldHeight / 2)) * 2
	end
end

return NewChunk
end

function Pass(OldChunk, Distortion)
GoalWidth = #OldChunk * 2
GoalHeight = #OldChunk[1] * 2

NewChunk = {}
for x = 1,GoalWidth - 2 do
	NewChunk[x] = {}
	for y = 1, GoalHeight - 2 do
			NewChunk[x][y] = 
			math.floor(
			(
			OldChunk
			[math.ceil(x / 2)]
			[math.ceil(y / 2)]
			+ 
			OldChunk
			[math.ceil((x + 1) / 2)]
			[math.ceil((y / 2))]
			+
			OldChunk
			[math.ceil((x / 2))]
			[math.ceil((y + 1) / 2)]
			) / 3
			) + (math.random() - 0.5) * Distortion
	end
end

return NewChunk
end


