require 'lib/wogen'
require 'lib/dungeon/main'
require 'data/tiles'
require 'data/player'
require 'data/animals'
require 'data/items'
require 'data/blueprints'
require 'data/help'
require 'data/mainMenu'


camera.x = 1
camera.y = 1
camera.width = 1
camera.height = 1
day = 1

selectedTile = {}
selectedTile[1]	= 0
selectedTile[2] = 0

looking = false
loading = false
loadingStep = 1

mainMenuScreen = true
inventoryScreen = false
crafting = false
toolScreen = false
craftSelection = 1
inventorySelection = 1
helpScreen = true
moveVector = {0,0}
ingame = false
currentLevel = {}
DungeonCrawling = false

gameUpdated = false
showMap = false
oldX = 0
oldY = 0

function love.load()
LoadingIMG1 = love.graphics.newImage(textureFolder .. "background1.png")
LoadingIMG2	= love.graphics.newImage(textureFolder .. "background2.png")
imgBanner 		= love.graphics.newImage(textureFolder .. "banner.png")
daynightCycle = love.image.newImageData(textureFolder .. "daynightcycle.png")
binaryanIMG = love.graphics.newImage(textureFolder .. "binaryan.png")
gameCanvas = love.graphics.newCanvas(800,600)
lightMap = love.graphics.newCanvas(800,600)
font = love.graphics.newFont("font/alagard.ttf",20)
love.graphics.setFont(font)
end

function attack()
	if SelectedAnimal then
		StatusMessage = "You swing your " .. blueprints[player.equippedTool].typeOf .. " at " .. SelectedAnimal.name
		SelectedAnimal.health = SelectedAnimal.health - math.random(player.strength * blueprints[player.equippedTool].attack)
		SelectedAnimal.Angry = true
		if SelectedAnimal.health < 1 then
					SelectedAnimal.dead = true
					
					lootAmount = math.random(math.ceil(SelectedAnimal.strength / 10))
					StatusMessage = StatusMessage .. ". " .. SelectedAnimal.name .. " died. You got " .. lootAmount .. " raw pieces of meat. "
					player.inventory[16] = player.inventory[16] + lootAmount
					if SelectedAnimal.lootID then
						for i = 1, #SelectedAnimal.lootID do
							lootAmount = math.random(math.ceil(SelectedAnimal.strength / 15))
							StatusMessage = StatusMessage .. "You got " .. lootAmount .. " " .. items[SelectedAnimal.lootID[i]].name .. "! " 
							player.inventory[SelectedAnimal.lootID[i]] = player.inventory[SelectedAnimal.lootID[i]] + lootAmount
						end
					end
					if math.ceil(SelectedAnimal.strength / 15) > player.strength then
					player.strength = player.strength + 1
					StatusMessage = StatusMessage .. "Your strength leveled up! "
					end
					--changeBGM(snowBGM)
				end
		end
end

function Shoot()
		local hasShot = false
		for i = 1, #player.crafts do
				if blueprints[player.crafts[i]].typeOf == "ammo" and hasShot == false then
						player.crafts[i] = nil
						hasShot = true
					end
				end
		if hasShot then
			if SelectedAnimal then
				StatusMessage = "You shot an arrow at " .. SelectedAnimal.name
				SelectedAnimal.health = SelectedAnimal.health - math.random(player.dexterity * blueprints[player.equippedTool].attack)
				SelectedAnimal.Angry = true
				--changeBGM(battleBGM)
				if SelectedAnimal.health < 1 then
					SelectedAnimal.dead = true
					player.dexterity = player.dexterity + 1
					lootAmount = math.random(math.ceil(SelectedAnimal.strength / 10))
					StatusMessage = StatusMessage .. ". " .. SelectedAnimal.name .. " died. You got " .. lootAmount .. " raw pieces of meat. "
					player.inventory[16] = player.inventory[16] + lootAmount
					if SelectedAnimal.lootID then
						for i = 1, #SelectedAnimal.lootID do
							lootAmount = math.random(math.ceil(SelectedAnimal.strength / 15))
							StatusMessage = StatusMessage .. "You got " .. lootAmount .. " " .. items[SelectedAnimal.lootID[i]].name .. "! " 
							player.inventory[SelectedAnimal.lootID[i]] = player.inventory[SelectedAnimal.lootID[i]] + lootAmount
						end
					end
					StatusMessage = StatusMessage .. "Your dexterity leveled up! "
					--changeBGM(snowBGM)
				end
			else
				StatusMessage = "You shot an arrow at nothing"
			end
			
		else
			StatusMessage = "You don't have any arrows."
		end
		newArray = {}
		for i = 1, #player.crafts do
			if player.crafts[i] then
				newArray[#newArray + 1] = player.crafts[i]
			end
		end
		player.crafts = newArray
end

function placeBlock()
local blockPlaced = false
if not tiles[currentLevel[sx][sy]].artificial and tiles[currentLevel[sx][sy]].walkable then
	if player.x == sx and player.y == sy then
			blockPlaced = false
	else
			currentLevel[sx][sy] = blueprints[player.equippedTool].tileID
			blockPlaced = true
	end
end
			if blockPlaced == true and tiles[blueprints[player.equippedTool].tileID].container then
			itemContainer[sx][sy] = {}
			itemContainer[sx][sy].items = {}
			end
			
			if tiles[currentLevel[sx][sy]].timeBloom then 
			agriculture[sx][sy] = minute 
			end
			
			local blocksLeft = 0
			local deleted = false
			
			for i = 1, #player.crafts do
				if player.crafts[i] == player.equippedTool then
					if deleted == false then 
						if blockPlaced == true then
						deleted = true
						player.crafts[i] = false
						end
					end
				blocksLeft = blocksLeft + 1				
				end
				end
				local newArray = {}
			for i = 1, #player.crafts do
				if player.crafts[i] then newArray[#newArray + 1] = player.crafts[i] end
			end
			player.crafts = newArray
			if blocksLeft < 2 then player.equippedTool = 0 end
			updateInventory()
end

function setLevel(level,newLevel)
currentLevel = {}
CollisionLayer = {}
Discovered = {}
if newLevel then
itemContainer = {}
agriculture = {}
end
for x = 1, #level do
	currentLevel[x] = {}
	CollisionLayer[x] = {}
	Discovered[x] = {}
	if newLevel then
	itemContainer[x] = {}
	agriculture[x] = {}
	end
	for y = 1, #level[1] do
		currentLevel[x][y] = level[x][y]
		if tiles[currentLevel[x][y]].walkable == false then
				CollisionLayer[x][y] = 2
		else
				CollisionLayer[x][y] = 1
		end
		Discovered[x][y] = false
		if newLevel then
		if tiles[currentLevel[x][y]].container then
				itemContainer[x][y] = {}
				itemContainer[x][y].items = {}
				lootAmount = math.random(10)
				for i = 1, lootAmount do
					itemContainer[x][y].items[i] = math.random(#blueprints)
				end
		end
		if tiles[currentLevel[x][y]].timeBloom then
				agriculture[x][y] = -math.random(tiles[World[x][y]].timeBloom)
		end
		end
	end
end

		--SpawnedAnimals = {}
		--agriculture = saveFile.agriculture
		--itemContainer = saveFile.items
		--SpawnedAnimals = saveFile.animals
		--CollisionLayer = saveFile.CollisionLayer
end

function eat()
		StatusMessage = StatusMessage .. "You eat some " .. blueprints[player.equippedTool].name .. "."
		local totalhealth = 0
		if blueprints[player.equippedTool].drugs then
		player.onDrugs = true
		player.minutesuntilSober = player.minutesuntilSober + blueprints[player.equippedTool].efficiency * 60
		StatusMessage = StatusMessage .. " You're feeling intoxicated."
		end
		for l = 1, #player.limbs do
		player.limbs[l].health = player.limbs[l].health + blueprints[player.equippedTool].efficiency * 10
		if player.limbs[l].health > player.limbs[l].maxHealth then player.limbs[l].health = player.limbs[l].maxHealth end
			totalhealth = totalhealth + player.limbs[l].health
		end
			player.health = totalhealth / #player.limbs
			local blocksLeft = 0
			local deleted = false
			for i = 1, #player.crafts do
				if player.crafts[i] == player.equippedTool then
					if deleted == false then 
						deleted = true
						player.crafts[i] = nil
					end
				blocksLeft = blocksLeft + 1				
				end
				
			end
				local newArray = {}
			for i = 1, #player.crafts do
				if player.crafts[i] then newArray[#newArray + 1] = player.crafts[i] end
			end
			player.crafts = newArray
			if blocksLeft < 2 then player.equippedTool = 0 end
			updateInventory()
end

function breakBlock()
local AbletoBreak = false
			if tiles[currentLevel[sx][sy]].toolNeeded then
					if player.equippedTool > 0 and tiles[currentLevel[sx][sy]].toolNeeded == blueprints[player.equippedTool].typeOf then
						AbletoBreak = true
			end
		else
			AbletoBreak = true
		end
		if AbletoBreak and tiles[currentLevel[sx][sy]].container then
			for i = 1, #itemContainer[x][y].items do 
				player.crafts[#player.crafts + 1] =  itemContainer[x][y].items[i]
			end
			itemContainer[x][y] = false
		end
		if AbletoBreak and sx == oldX and sy == oldY then
		--if AbletoBreak then
						if tiles[currentLevel[sx][sy]].lootID then
							lootID = tiles[currentLevel[sx][sy]].lootID
							lootAmount = math.random(tiles[currentLevel[sx][sy]].lootAmount)
								if player.equippedTool > 0 then
									lootAmount = math.ceil(lootAmount * blueprints[player.equippedTool].efficiency)
								end
							if items[lootID].autoCraftID then
							player.crafts[#player.crafts + 1] = items[lootID].autoCraftID
							else
							player.inventory[lootID] =  player.inventory[lootID] + lootAmount
							end
							StatusMessage = "You got " .. lootAmount .. " " .. items[lootID].name .. "!"
						end
			currentLevel[sx][sy] = tiles[currentLevel[sx][sy]].ReplacementID
			agriculture[sx][sy] = false
				end
	oldX = sx
	oldY = sy
end

function love.keypressed(key)
print(#SpawnedAnimals)
 if key == "[" then
    dmg.current_palette = dmg.current_palette - 1
    if dmg.current_palette < 1 then
      dmg.current_palette = #dmg.palette
    end
 elseif key == "]" then
    dmg.current_palette = dmg.current_palette + 1
    if dmg.current_palette > #dmg.palette then
      dmg.current_palette = 1
	end
end
if mainMenuScreen then
	mainMenu.keyPressed(key)
elseif ingame then

lastmove_dt = lastmove - 0.01
if selectedTile[1] and selectedTile[2] then
	sx = selectedTile[1]
	sy = selectedTile[2]
else
	sx = player.x
	sy = player.y
end
StatusMessage = ""
if key == "w" or key == "up"  then
moveVector[2] = -1
end
if key == "a" or key == "left"  then
moveVector[1] = -1
end
if key == "s" or key == "down"  then
moveVector[2] = 1
end
if key == "d" or key == "right"  then
moveVector[1] = 1
end

if itemScreen or inventoryScreen or crafting or showMap or survivalLog then 
moveVector = {0,0}
end

if  moveVector[1] == 1 or moveVector[2] == 1 or moveVector[1] == -1 or moveVector[2] == -1 then
	if player.limbs[4].health < 1 then
		moveVector = {0,0}
		StatusMessage = StatusMessage .. " You try to move but your legs are broken."	
	end
	oldX = 0
	oldY = 0
end
	if key == "f1" then helpScreen = not helpScreen end
	if key == "r" then
			player_load()
			gameover = false
			player_newLocation()
			while tiles[currentLevel[player.x][player.y]].walkable == false do 
				player_newLocation()
				selectedTile[1] = player.x
				selectedTile[2] = player.y
			end
			updateAnimals(camera.x,camera.y,camera.width,camera.height,CollisionLayer)
			player_update()
	elseif key == "l" then
	looking = not looking
	selectedTile[1] = player.x
	selectedTile[2] = player.y
	elseif key == "q" then
	survivalLog = not survivalLog
	elseif key == "m" then
	showMap = not showMap
	elseif key == " " and ingame and not crafting and not inventoryScreen and not gameover and not survivalLog  then
		sx = selectedTile[1]
		sy = selectedTile[2]
		local armsBroken = false
		if player.limbs[3].health < 1 then
			armsBroken = true
		end
			
		if tiles[currentLevel[sx][sy]].switchID then currentLevel[sx][sy] = tiles[currentLevel[sx][sy]].switchID
		end
		
		if tiles[currentLevel[sx][sy]].perk == "sleep" then minute = minute + 8 * 60 end
		
		if tiles[currentLevel[sx][sy]].perk == "dungeon" then 
		generateDungeon(true,94,84,82,{34,35,91,90,88,78,77})
		DungeonCrawling = true
		DungeonGenerated = false
		end
		
		if not DungeonCrawling then World = currentLevel end
		
		if player.equippedTool > 0 and blueprints[player.equippedTool].typeOf == "ranged" then
			if selectedTile[1] < player.x + blueprints[player.equippedTool].range and
			selectedTile[1] > player.x - blueprints[player.equippedTool].range and
			selectedTile[2] < player.y + blueprints[player.equippedTool].range and
			selectedTile[2] > player.y - blueprints[player.equippedTool].range then
			if not armsBroken then
			Shoot()
			else
			StatusMessage = StatusMessage .. "You try to shoot but your arms are crippled." 
			end
			else
			StatusMessage = StatusMessage .. "You try to shoot out of your range!"
		end
		elseif SelectedAnimal and player.equippedTool > 0 and blueprints[player.equippedTool].typeOf ~= "ranged" and blueprints[player.equippedTool].attack then
			if selectedTile[1] < player.x + blueprints[player.equippedTool].range and
			selectedTile[1] > player.x - blueprints[player.equippedTool].range and
			selectedTile[2] < player.y + blueprints[player.equippedTool].range and
			selectedTile[2] > player.y - blueprints[player.equippedTool].range then
				if not armsBroken then
					attack()
				else
					StatusMessage = StatusMessage .. "You try to attack but your arms are crippled." 
				end
			else
				StatusMessage = StatusMessage .. "You try to attack out of your range!"
			end
		elseif player.equippedTool > 0 and blueprints[player.equippedTool].typeOf == "block" then
			if not armsBroken then
			placeBlock()
			else
			StatusMessage = StatusMessage .. "You try to place something but your arms are crippled." 
			end
		elseif player.equippedTool > 0 and blueprints[player.equippedTool].typeOf == "food" then
			eat()
		elseif tiles[currentLevel[sx][sy]].breakable then
			if not armsBroken then
			breakBlock()
			else
			StatusMessage = StatusMessage .. "You try to remove something but your arms are crippled." 
			end
		end
		updateAnimals(camera.x,camera.y,camera.width,camera.height,CollisionLayer)
		player_update()
		
	elseif key == "c" then
		if tiles[currentLevel[sx][sy]].container then
			itemScreen = true
			currentContainerLoc = {sx,sy}
		else
			CraftingActivity = "Please select a blueprint to craft."
			updateCraftingMenu()
			if not inventoryScreen then crafting = not crafting end
		end
	elseif key == "i" then
	updateInventory()
	if not crafting then inventoryScreen = not inventoryScreen end
	end
	if crafting and key == "down" then
		craftSelection = craftSelection + 1
		updateCraftingMenu()
	elseif crafting and key == "up" then
		craftSelection = craftSelection - 1
		updateCraftingMenu()
	elseif survivalLog and key == "down" then
		achievementSelection = achievementSelection + 1
	elseif survivalLog and key == "up" then
		achievementSelection = achievementSelection - 1
	elseif inventoryScreen and key == "down" then
		inventorySelection = inventorySelection + 1
		updateInventory()
	elseif inventoryScreen and key == "up" then
		inventorySelection = inventorySelection - 1
		updateInventory()
	elseif key == "f11" then
		love.graphics.toggleFullscreen( )
		MapGenerated = false
	elseif key == "f6" then
		saving = true
		savingStep = 0
	elseif inventoryScreen and key == "return" and #inventoryTools > 0 then
			local selection = inventoryTools[inventorySelection].ID
		if blueprints[selection].typeOf ~= "armor" then
			if player.equippedTool == inventoryTools[inventorySelection].ID then player.equippedTool = 0
			else player.equippedTool = inventoryTools[inventorySelection].ID end
		elseif blueprints[selection].typeOf == "armor" then
			local cs = blueprints[selection]
			if cs.armorType == "vest" then
				player.vest = cs.ID
			elseif cs.armorType == "pants" then
				player.pants = cs.ID
			elseif cs.armorType == "helmet" then
				player.helmet = cs.ID
			elseif cs.armorType == "shoes" then
				player.shoes = cs.ID
			elseif cs.armorType == "gloves" then
				player.gloves = cs.ID
			end
		end

		
	elseif crafting and key == "return" and #possibleCraftsList > 0  then
		CraftingActivity = "You crafted " .. possibleCraftsList[craftSelection].name
		if possibleCraftsList[craftSelection].autoTransform then
			local tempItemID = possibleCraftsList[craftSelection].autoTransform
			player.inventory[tempItemID] = player.inventory[tempItemID] + 1
		else
			player.crafts[#player.crafts + 1] =  possibleCraftsList[craftSelection].ID
		end
		for n = 1, #possibleCraftsList[craftSelection].itemIDNeeded do
			local itemID = 		possibleCraftsList[craftSelection].itemIDNeeded[n]
			local itemAmount = 	possibleCraftsList[craftSelection].itemAmountNeeded[n]
			player.inventory[itemID] = player.inventory[itemID] - itemAmount
		end
		updateCraftingMenu()
	end
	if key == "escape" then
		crafting = false
		inventoryScreen = false
		itemScreen = false
		helpScreen = false
		survivalLog = false
		
	end
if tiles[currentLevel[sx][sy]].walkable == false then
	CollisionLayer[sx][sy] = 2
else
	CollisionLayer[sx][sy] = 1
end
 
 if achievementSelection > #achievements then achievementSelection = 1 end
 if achievementSelection < 1 then achievementSelection = #achievements end
 
if itemScreen then
	updateItemMenu(key,currentContainerLoc[1],currentContainerLoc[2])
end
calculateLight(camera.x, camera.y,camera.width,camera.height)
if shownHour == 23 and 1 == 2 then
			local tempx = camera.x + math.random(camera.width)
			local tempy = camera.y + math.random(camera.height)
				print("it's past 23:00")
				while FieldOfView[tempx][tempy] or FieldOfLight[tempx][tempy]  do
					tempx = camera.x + math.random(camera.width)
					tempy = camera.y + math.random(camera.height)
				end
				
				if math.random(10) == 1 then
					spawnEnemy(tempx,tempy)
					print("enemy spawned")
				end
			end
end

	if DungeonCrawling == true and DungeonGenerated == false then
		setLevel(dungeon)
		player_newLocation()
		selectedTile[1] = player.x
		selectedTile[2] = player.y
		spawnEnemies()
		camera.clamp()
		player_rayCast(camera.x,camera.y,camera.width,camera.height)
		DungeonGenerated = true
	end
end

function updateAgriculture()
for x = camera.x, camera.x + camera.width do
	for y = camera.y, camera.y + camera.height do
		if agriculture[x][y] and tiles[currentLevel[x][y]].timeBloom and minute - agriculture[x][y]  > tiles[currentLevel[x][y]].timeBloom then
				currentLevel[x][y] = tiles[currentLevel[x][y]].transformTo
				agriculture[x][y] = false
			end
		end
	end
end

function updateItemMenu(key,x,y)
	if not itemContainer[x][y].items then
		itemContainer[x][y].items = {}
	end
if not ItemSelection then
ItemSelection = {}
ItemSelection[1] = 1
ItemSelection[2] = 1 
end
if not itemColumnSelection then
itemColumnSelection = 1
end
	itemRemoved = false
	if key == "down" then
		ItemSelection[itemColumnSelection] = ItemSelection[itemColumnSelection] + 1
	elseif key == "up" then
		ItemSelection[itemColumnSelection] = ItemSelection[itemColumnSelection] - 1
	elseif key == "left" then
		itemColumnSelection = 1
	elseif key == "right" then
		itemColumnSelection = 2
	elseif key == "return" then
		if itemColumnSelection == 1 then
			if #inventoryTools > 0 then
		itemContainer[x][y].items[#itemContainer[x][y].items + 1] = inventoryTools[ItemSelection[1]].ID
		itemRemoved = true
		deleted = false
			end
		elseif itemColumnSelection == 2 then
			if #itemContainer[x][y].items > 0 then
		player.crafts[#player.crafts + 1] =  itemContainer[x][y].items[ItemSelection[2]]
		itemContainer[x][y].items[ItemSelection[2]] = nil
			end
		end
end
	local newArray = {}
	for i = 1, #itemContainer[x][y].items do
				if itemContainer[x][y].items[i] then newArray[#newArray + 1] = itemContainer[x][y].items[i] end
			end
	itemContainer[x][y].items = newArray
	
if itemRemoved == true then
	for i = 1, #player.crafts do
				if player.crafts[i] == inventoryTools[ItemSelection[1]].ID then
					if deleted == false then 
						deleted = true
						player.crafts[i] = false
					end			
				end
	end
end
				local newArray = {}
			for i = 1, #player.crafts do
				if player.crafts[i] then newArray[#newArray + 1] = player.crafts[i] end
			end
			player.crafts = newArray
updateInventory()
if ItemSelection[1] < 1 then ItemSelection[1] = #inventoryTools
		elseif ItemSelection[1] > #inventoryTools then ItemSelection[1] = 1 end
if ItemSelection[2] < 1 then ItemSelection[2] = #itemContainer[x][y].items
		elseif ItemSelection[2] > #itemContainer[x][y].items then ItemSelection[2] = 1 end
end

function updateInventory()
inventoryTools = {}
inventoryTools.ID = {}
inventoryTools.Amount = {}
 for i = 1, #player.crafts do
	local duplicate = false
	for n = 1, #inventoryTools do
		if player.crafts[i] == inventoryTools[n].ID then
			inventoryTools[n].Amount = inventoryTools[n].Amount + 1
			duplicate = true
		end
		
	end
	if duplicate == false then
		inventoryTools[#inventoryTools + 1] = {}
		inventoryTools[#inventoryTools].ID = player.crafts[i]
		inventoryTools[#inventoryTools].Amount = 1
	end
end
if inventorySelection < 1 then inventorySelection = #inventoryTools
		elseif inventorySelection > #inventoryTools then inventorySelection = 1 end
end

function updateCraftingMenu()
	
possibleCraftsList = {}
	for i = 1, #blueprints do
		local temppossible = true
		if tiles[currentLevel[sx][sy]].perk ~= blueprints[i].perkNeeded then
			temppossible = false
			end
		if blueprints[i].toolNeeded and blueprints[i].toolNeeded ~= blueprints[player.equippedTool].typeOf then
			temppossible = false
		end
		if blueprints[i].itemIDNeeded then
		for n = 1, #blueprints[i].itemIDNeeded do
			local itemID = 		blueprints[i].itemIDNeeded[n]
			local itemAmount = 	blueprints[i].itemAmountNeeded[n]
			if player.inventory[itemID] < itemAmount then
				temppossible = false
			end
			
		end
		else
			temppossible = false
		end
		if temppossible then
			possibleCraftsList[#possibleCraftsList + 1] = blueprints[i]
			possibleCraftsList[#possibleCraftsList].ID = i
		end
	end
	updateInventory()
if craftSelection < 1 then craftSelection = #possibleCraftsList
		elseif craftSelection > #possibleCraftsList then craftSelection = 1 end
end

function LoadGame(step)
if step == 1 then
cursorImg = love.graphics.newImage(textureFolder .. "cursor.png")
love.graphics.setLineWidth(1)
loadTiles()
loadItems()
loadBlueprints()
LoadingText = "Calculating Climates"
elseif step == 2 then
GenerateBiomes()
LoadingText = "Generating Terrain"
elseif step == 3 then
GenerateWorld(tiles)
setLevel(World)
LoadingText = "Generating Entities"
elseif step == 4 then
player_load()
tileHeight = player.img:getHeight()
tileWidth = player.img:getWidth()
camera.width = math.ceil(800 / tileWidth)
camera.height = math.ceil(500 / tileHeight)
Map = love.graphics.newCanvas(#World,#World[1])
MapGenerated = false
player_newLocation()
	while tiles[World[player.x][player.y]].walkable == false do 
	player_newLocation() 
	end
loadAnimals()
spawnAnimals()
selectedTile = {}
selectedTile[1] = player.x
selectedTile[2] = player.y
elseif step == 5 then
elseif step == 6 then
newWorld = false
ingame = true
--changeBGM(snowBGM)
end
end

function love.update(dt)
	if newWorld then
		LoadGame(loadingStep)
		loadingStep = loadingStep + 1
	elseif ingame and not crafting and not inventoryScreen and not gameover and not survivalLog then
		updateGame(dt)
	end
	
	if saving == true then
		saveGame(savingStep)
		savingStep = savingStep + 1
	end
	
	
	if player.health and player.health < 1 then
		gameover = true
	end
end

lastmove = 0.10
lastmove_dt = lastmove

function updateGame(dt)
lastmove_dt = lastmove_dt - dt
if lastmove_dt <= 0 then
	lastmove_dt = lastmove
end

if lastmove_dt == lastmove then
if love.keyboard.isDown("w") or love.keyboard.isDown("up")  then
moveVector[2] = -1
StatusMessage = ""
end
if love.keyboard.isDown("a") or love.keyboard.isDown("left") then
moveVector[1] = -1
StatusMessage = ""
end
if love.keyboard.isDown("s") or love.keyboard.isDown("down") then
moveVector[2] = 1
StatusMessage = ""
end
if love.keyboard.isDown("d") or love.keyboard.isDown("right") then
moveVector[1] = 1
StatusMessage = ""
end
end

if not looking then
if  moveVector[1] == 1 or moveVector[2] == 1 or moveVector[1] == -1 or moveVector[2] == -1 then
	if player.limbs[4].health < 1 then
		moveVector = {0,0}
	end
goalVector = {player.x + moveVector[1],player.y + moveVector[2]}
else
goalVector = {player.x, player.y}
end

if goalVector[1] > 1 and goalVector[2] > 1 and goalVector[1] < #currentLevel - 1 and goalVector[2] < #currentLevel[1] - 1 then
	if tiles[currentLevel[goalVector[1]][goalVector[2]]].walkable then
			canWalk = true
			playerSprite = player.img
	elseif blueprints[player.equippedTool].typeOf == "vehicle" then
		canWalk = false
		for i = 1, #blueprints[player.equippedTool].canRide do
			if currentLevel[goalVector[1]][goalVector[2]] == blueprints[player.equippedTool].canRide[i] then
			 canWalk = true
			 playerSprite = blueprints[player.equippedTool].vehicleIMG
			end
		end
	else
		canWalk = false
	end
	if canWalk then
		player.x = goalVector[1]
		player.y = goalVector[2]
		if moveVector[1] == 1 or moveVector[2] == 1 or moveVector[1] == -1 or moveVector[2] == -1 then
		updateAnimals(camera.x,camera.y,camera.width,camera.height,CollisionLayer)
		player_update()
	end
end
end

if moveVector[1] == 1 or moveVector[2] == 1 or moveVector[1] == -1 or moveVector[2] == -1 then
selectedTile = {player.x + moveVector[1], player.y + moveVector[2]}
end
else
	if FieldOfView[selectedTile[1] + moveVector[1]][selectedTile[2] + moveVector[2]] then
selectedTile = {selectedTile[1] + moveVector[1],selectedTile[2] + moveVector[2]}
	end
end

camera.x = player.x - camera.width / 2
camera.y = player.y - camera.height / 2
camera.clamp()
player_rayCast(camera.x,camera.y,camera.width,camera.height)
gameUpdated = true
moveVector = {0,0}
end

function camera.clamp()
if camera.x < 1 then camera.x = 1 end
if camera.y < 1 then camera.y = 1 end
if camera.x > #currentLevel - camera.width then camera.x = #currentLevel - camera.width end
if camera.y > #currentLevel[1] - camera.height then camera.y = #currentLevel[1] - camera.height end
end

function love.draw()

	if mainMenuScreen then
		if Binaryan then
			love.graphics.rectangle("fill",0,0,800,600)
			--love.graphics.setBlendMode("multiplicative")
			love.graphics.draw(binaryanIMG,800 - binaryanIMG:getWidth() ,0)
			--love.graphics.setBlendMode("alpha")
		else
			love.graphics.setColor(255,255,255)
			love.graphics.draw(LoadingIMG2,0,0)
			love.graphics.draw(LoadingIMG1,0,0)
		end
		love.graphics.setColor(255,255,255)
		for i = 1, #currentMenu do 
				if i == mainMenuSelection then
					if currentMenu[i].img then
						love.graphics.setColor(255,255,255)
						love.graphics.rectangle("fill",400 - currentMenu[i].img:getWidth(),200 - currentMenu[i].img:getHeight(),currentMenu[i].img:getWidth() * 2, currentMenu[i].img:getHeight() * 2)
						love.graphics.draw(currentMenu[i].img,400 - (currentMenu[i].img:getWidth() / 2) ,200 - (currentMenu[i].img:getHeight() / 2))
					end
					love.graphics.setColor(255,0,0) else love.graphics.setColor(50,0,0) 
				end 
			love.graphics.printf(currentMenu[i].name,0,300 + (i - mainMenuSelection) * 30,800,"center")
		end
		love.graphics.setColor(255,255,255)
		love.graphics.draw(imgBanner,400,50,0,1,1,imgBanner:getWidth()/2,0)
		love.graphics.setColor(0,255,255)
		love.graphics.setColor(255,255,255)
			
		
	elseif newWorld then
		love.graphics.draw(LoadingIMG2,0,0)
		love.graphics.draw(LoadingIMG1,0,0)
		love.graphics.draw(imgBanner,400,50,0,1,1,imgBanner:getWidth()/2,0)
		love.graphics.setColor(255,255,255)
		love.graphics.printf("Loading (Step " .. loadingStep .. ": " .. LoadingText .. ")", 0,500,800,"center")
	elseif gameUpdated then
		gameCanvas:clear()
		love.graphics.setCanvas(gameCanvas)
		drawGame()
		love.graphics.setCanvas()
		love.graphics.setColor(255,255,255)
		drawLightMap()
		love.graphics.draw(gameCanvas,0,0)
		if gameover then
			love.graphics.printf("GAMEOVER \n\n" ..
			"please press 'r' to retry", 20, 300, 800, "center" )
		elseif itemScreen then
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",0,0,800,600)
			love.graphics.setColor(255,255,255)
			local cx = currentContainerLoc[1]
			local cy = currentContainerLoc[2]
			for i = 1, #inventoryTools do
				if ItemSelection[1] == i and itemColumnSelection == 1 then
				love.graphics.setColor(255,0,0)
				else
				love.graphics.setColor(255,255,255)
				end
				tempString = blueprints[inventoryTools[i].ID].name .. " [" .. inventoryTools[i].Amount .. "]"
				love.graphics.print(tempString,20,300 + ((i - ItemSelection[1]) * 20))
			end
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",400,0,400,600)
			love.graphics.setColor(255,255,255)
			love.graphics.line(400,0,400,600)
			for i = 1, #itemContainer[cx][cy].items do
				if ItemSelection[2] == i and itemColumnSelection == 2 then
				love.graphics.setColor(255,0,0)
				else
				love.graphics.setColor(255,255,255)
				end
				love.graphics.print(blueprints[itemContainer[cx][cy].items[i]].name,420,300 + ((i - ItemSelection[2]) * 20))
			end
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",0,0,800,50)
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle("line",0,0,800,50)
			if itemColumnSelection == 1 then love.graphics.setColor(255,0,0) else love.graphics.setColor(0,255,255) end
			love.graphics.printf("Inventory",0,20,400,"center")
			if itemColumnSelection == 2 then love.graphics.setColor(255,0,0) else love.graphics.setColor(0,255,255) end
			love.graphics.printf("Container",400,20,400,"center")
		elseif inventoryScreen then
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",0,0,800,600)
			newList = {}
			for i = 1, #player.inventory do
				if player.inventory[i] > 0 then
				newList[#newList + 1] = items[i].name .. ": " .. player.inventory[i]
				end
			end
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",275,0,525,600)
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle("line",0,0,275,600)
			for i = 1, #inventoryTools do
				if inventorySelection == i then love.graphics.setColor(255,0,0) else love.graphics.setColor(255,255,255) end
				local tempString = ""
				if inventoryTools[i].ID == player.equippedTool then
				tempString = tempString .. "[E]"
				elseif inventoryTools[i].ID == player.vest then
				tempString = tempString .. "[v]"
				elseif inventoryTools[i].ID == player.pants then
				tempString = tempString .. "[p]"
				elseif inventoryTools[i].ID == player.helmet then
				tempString = tempString .. "[h]"
				elseif inventoryTools[i].ID == player.shoes then
				tempString = tempString .. "[s]"
				elseif inventoryTools[i].ID == player.gloves then
				tempString = tempString .. "[g]"
				end
				tempString = tempString .. blueprints[inventoryTools[i].ID].name .. " [" .. inventoryTools[i].Amount .. "]"
				love.graphics.print(tempString,300,300 + ((i - inventorySelection) * 20))
			end
			love.graphics.setColor(255,255,255)
			for i = 1, #newList do
				love.graphics.print(newList[i],20,50 + i * 20)
			end
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",0,0,800,60)
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle("line",0,0,800,60)
			love.graphics.print("Inventory",20,20)
			love.graphics.print("Tools",250,20)
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",0,500,800,100)
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle("line",0,500,800,100)
			love.graphics.setColor(255,0,0)
			if #inventoryTools > 0 then
			love.graphics.printf(blueprints[inventoryTools[inventorySelection].ID].description
				, 20, 510, 760, "left" )
			end

		elseif crafting then
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill",0,0,800,600)
		requirements = ""
		newList = {}
		
		for i = 1, #player.inventory do
				if player.inventory[i] > 0 then
				newList[#newList + 1] = items[i].name .. ": " .. player.inventory[i]
				end
		end
		love.graphics.setColor(255,255,255)
		for i = 1, #newList do
				love.graphics.print(newList[i],20,50 + i * 20)
		end
		love.graphics.setColor(0,0,0)
		love.graphics.rectangle("fill",275,0,525,600)
		love.graphics.setColor(255,255,255)
		love.graphics.rectangle("line",0,0,275,600)
		for i = 1, #possibleCraftsList do
			if craftSelection == i then
				love.graphics.setColor(255,0,0)
				love.graphics.print("[" .. possibleCraftsList[i].name .. "]",300,300 + (i - craftSelection) * 20)
				

			else
				love.graphics.setColor(255,255,255)
				love.graphics.print(possibleCraftsList[i].name,300,300 + (i - craftSelection) * 20)
			end
			
			
			requirements = "It costs "
				for n = 1, #possibleCraftsList[craftSelection].itemIDNeeded do
					itemID = possibleCraftsList[craftSelection].itemIDNeeded[n]
					requirements = requirements .. possibleCraftsList[craftSelection].itemAmountNeeded[n] .. " " ..
					items[itemID].name .. ","
				end
			requirements = requirements .. " to craft."
		end
		love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",0,0,800,60)
			love.graphics.rectangle("fill",0,500,800,100)
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle("line",0,0,800,60)
			love.graphics.rectangle("line",0,500,800,100)
			love.graphics.setColor(0,255,255)
			if tiles[currentLevel[sx][sy]].perk then 
			MenuName = tiles[currentLevel[sx][sy]].perk
			else
			MenuName = "crafting"
			end
			love.graphics.printf(MenuName .. " menu",0,20,800,"center")
			love.graphics.print(CraftingActivity,20,520)
			love.graphics.setColor(255,0,0)
			if possibleCraftsList[craftSelection] then
			love.graphics.printf(possibleCraftsList[craftSelection].description .. " " .. requirements
				, 20, 550, 760, "left" )
			else
			love.graphics.printf("There is no crafting possible with your materials, harvest some more and try again later, to unlock more crafts.", 20, 550, 760, "left" )
			end
		elseif helpScreen then
			love.graphics.setColor(0,0,0,200)
			love.graphics.rectangle("fill",0,0,800,600)
			love.graphics.setColor(255,0,0)
			love.graphics.printf(helpText, 20, 75, 780, "center" )
		elseif showMap then
			xScale = 600 / Map:getWidth()
			yScale = 600 / Map:getHeight()
			love.graphics.setColor(0,0,100)
			love.graphics.rectangle("fill",0,0,800,600)
			love.graphics.setColor(255,255,255)
			love.graphics.draw(Map,100,0,0,xScale,yScale)
			love.graphics.setColor(255,0,0)
			love.graphics.printf("[World map]", 20, 20, 780, "center" )
			love.graphics.print("X",100 + (player.x * xScale) - 4,(player.y * yScale) - 4)
		elseif survivalLog then
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",0,0,800,600)
			for a = 1,#achievements do
				 if player.achievements[a] == true then
					achievementStatus = "[Finished!]"
				else
					achievementStatus = "[Unfinished]"
				 end
				 if a == achievementSelection then love.graphics.setColor(255,0,0) else love.graphics.setColor(100,0,0) end
				love.graphics.printf(achievements[a].name .. " " .. achievementStatus , 20, 200 - (achievementSelection -a) * 20, 780, "center" )
			end
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",0,0,800,50)
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle("line",0,0,800,50)
			love.graphics.setColor(0,255,255)
			love.graphics.printf("Survival Strategy Guide", 20, 10, 780, "center" )
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("fill",0,400,800,200)
			love.graphics.setColor(255,255,255)
			love.graphics.rectangle("line",0,400,800,200)
			love.graphics.setColor(0,255,255)
			love.graphics.printf(achievements[achievementSelection].description, 20, 410, 780, "left" )
		end
	end

end

function calculateLight(CamX,CamY,CamWidth,CamHeight)
CastedLines = {}
lightLength = 8
TotalSteps = 360
DistanceBetweenRay = 1
--print("calculating light...")
FieldOfLight = {}
	for x = CamX, CamX + CamWidth do
		FieldOfLight[x] = {}
		for y = CamY, CamY + CamHeight do
			FieldOfLight[x][y] = 0
		end
	end
	for x = CamX, CamX + CamWidth do
		for y = CamY, CamY + CamHeight do
			--print("searching on ".. x .. "x" ..y .. " = " .. tiles[World[x][y]].name)
			if tiles[currentLevel[x][y]].lightSource then
				--print("lightsource at ".. x .. "x" ..y)
				for i = 1, TotalSteps do
				CastedLines[i] = {}
				CastedLines[i].x = x
				CastedLines[i].y = y
				tempLength = 0.5
				endFound = false
				while tempLength < lightLength and endFound == false do
					if CastedLines[i].x > 1 and CastedLines[i].x < #World - 1 and
					CastedLines[i].y > 1 and CastedLines[i].y < #World[1] - 1 then
						if tiles[currentLevel[CastedLines[i].x][CastedLines[i].y]].lookthrough then
						CastedLines[i].x = math.floor(x + 0.5 + math.cos(i * DistanceBetweenRay) * tempLength)
						CastedLines[i].y = math.floor(y + math.sin(i * DistanceBetweenRay) * tempLength)
						
						if CastedLines[i].x > CamX and CastedLines[i].y > CamY and 
						CastedLines[i].x < CamX + CamWidth and 
						CastedLines[i].y < CamY + CamHeight and 
						FieldOfLight[CastedLines[i].x][CastedLines[i].y] then
						
						FieldOfLight[CastedLines[i].x][CastedLines[i].y] = FieldOfLight[CastedLines[i].x][CastedLines[i].y] + (lightLength + 1 - tempLength) 
						elseif CastedLines[i].x > CamX and CastedLines[i].y > CamY and 
						CastedLines[i].x < CamX + CamWidth and 
						CastedLines[i].y < CamY + CamHeight and 
						FieldOfLight[CastedLines[i].x][CastedLines[i].y] then
						FieldOfLight[CastedLines[i].x][CastedLines[i].y] = (lightLength + 1 - tempLength) 
						end
						
						--print("light at ".. x .. "x" ..y)
						tempLength = tempLength + 0.5
						else
						endFound = true
						end
					else
					endFound = true
					end
				end
		end
	end
		end
	end
end

function drawLightMap()
	local r,g,b,a = daynightCycle:getPixel(shownHour,0)
	lightMap:clear(r,g,b)
	love.graphics.setCanvas(lightMap)
	love.graphics.setBlendMode("additive")
	local animOffset = (math.random(2) - 1)
	for x = camera.x, camera.x + camera.width do
		for y = camera.y, camera.y + camera.height do
			if FieldOfLight and FieldOfLight[x] and FieldOfLight[x][y] then
				if FieldOfLight[x][y] > 7 then TempLight = 7 else TempLight = FieldOfLight[x][y] end
				local lightvalue = (TempLight - animOffset) * 25
				if lightvalue > 255 then lightvalue = 255 elseif lightvalue < 1 then lightvalue = 1 end
				love.graphics.setColor(lightvalue,lightvalue,0)
				love.graphics.rectangle("fill", (x - camera.x) * tileWidth ,(y - camera.y) * tileHeight, tileWidth,tileHeight)
				love.graphics.setColor(255,255,255)
			end
		end
	end
	love.graphics.setCanvas()
	love.graphics.setBlendMode("alpha")
end

function drawGame()
SelectedAnimal = false
if MapGenerated == false then
Map:clear(0,0,0)
love.graphics.setCanvas(Map)
love.graphics.setColor(0,0,100)
love.graphics.rectangle("fill",0,0,#World,#World[2])
for x = 1, #World do
		for y = 1, #World[2] do
			--if Discovered[x][y] then
				tile = tiles[World[x][y]]
				if y > 1 and Chunk[x][y] < Chunk[x][y - 1] then
				transparency = 200
				else
				transparency = 255
				end
				
				love.graphics.setColor(0,0,0)
				if math.random(4) > 1 then
				love.graphics.setColor(tile.backcolor[1],tile.backcolor[2],tile.backcolor[3],transparency)
				else
				love.graphics.setColor(tile.forecolor[1],tile.forecolor[2],tile.forecolor[3],transparency)
				end
				if Chunk[x][y] < 5 then
				love.graphics.setColor(0,0,100)
				end
				love.graphics.rectangle("fill",x,y,2,2)
			--end
		end
end
MapGenerated = true
love.graphics.setCanvas()
end
local transperancy = (1 - (math.abs(shownHour - 12) / 20))
	for x = camera.x, camera.x + camera.width do
		for y = camera.y, camera.y + camera.height do
	if Discovered[x][y] then
			tile = tiles[currentLevel[x][y]]
			love.graphics.setColor(tile.backcolor[1],tile.backcolor[2],tile.backcolor[3],transperancy * 200)
			love.graphics.rectangle("fill", (x - camera.x) * tileWidth ,(y - camera.y) * tileHeight, tileWidth,tileHeight)
			if tile.backImg then
			love.graphics.draw(tile.backImg,(x - camera.x) * tileWidth,(y - camera.y) * tileHeight)
			end
			love.graphics.setColor(tile.forecolor[1],tile.forecolor[2],tile.forecolor[3], transperancy * 200)
			love.graphics.draw(tile.img,(x - camera.x) * tileWidth,(y - camera.y) * tileHeight)
			end
		end
	end
	
	for x = camera.x, camera.x + camera.width do
		for y = camera.y, camera.y + camera.height do
			tile = tiles[currentLevel[x][y]]
			if player.x == x and player.y == y then
			love.graphics.setColor(tile.backcolor[1],tile.backcolor[2],tile.backcolor[3])
			love.graphics.rectangle("fill", (x - camera.x) * tileWidth ,(y - camera.y) * tileHeight, tileWidth,tileHeight)
			love.graphics.setColor(255,255,255)
			love.graphics.draw(playerSprite,(x - camera.x) * tileWidth,(y - camera.y) * tileHeight)
			elseif FieldOfView[x][y] then
			if player.onDrugs then
						love.graphics.setColor(
						(shownMinute % 10) * 20 + 15,
						tile.backcolor[(player.y % 3) + 1],
						tile.backcolor[(player.x % 3) + 1])
			else
			love.graphics.setColor(tile.backcolor[1],tile.backcolor[2],tile.backcolor[3])
			end
			love.graphics.rectangle("fill", (x - camera.x) * tileWidth ,(y - camera.y) * tileHeight, tileWidth,tileHeight)
			if tile.backImg then
			love.graphics.draw(tile.backImg,(x - camera.x) * tileWidth,(y - camera.y) * tileHeight)
			end
			love.graphics.setColor(tile.forecolor[1],tile.forecolor[2],tile.forecolor[3])
			love.graphics.draw(tile.img,(x - camera.x) * tileWidth,(y - camera.y) * tileHeight)
			end
			
			if FieldOfView[x][y] then
				for n = 1, #SpawnedAnimals do
					if SpawnedAnimals[n].x == x and SpawnedAnimals[n].y == y then
						if selectedTile[1] == x and selectedTile[2] == y then
						SelectedAnimal = SpawnedAnimals[n]
						end
						love.graphics.setColor(tile.backcolor[1],tile.backcolor[2],tile.backcolor[3])
						love.graphics.rectangle("fill", (x - camera.x) * tileWidth ,(y - camera.y) * tileHeight, tileWidth,tileHeight)
						love.graphics.setColor(SpawnedAnimals[n].forecolor[1],SpawnedAnimals[n].forecolor[2],SpawnedAnimals[n].forecolor[3])
						love.graphics.draw(SpawnedAnimals[n].img,(x - camera.x) * tileWidth,(y - camera.y) * tileHeight)
					end
				end
			end
			
			
			
			if selectedTile[1]== x and selectedTile[2] == y then
			love.graphics.setColor(255,0,0)
			love.graphics.draw(cursorImg,(x - camera.x) * tileWidth,(y - camera.y) * tileHeight)
			end
		end
	end
	
	love.graphics.setBlendMode("multiplicative")
	love.graphics.setColor(255,255,255)
	love.graphics.draw(lightMap,0,0)
	love.graphics.setBlendMode("alpha")
	
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill",0,400,800,200)
	love.graphics.setColor(255,255,255)
	love.graphics.rectangle("line",0,400,800,200)
	local status = "Equipped: " .. blueprints[player.equippedTool].name .. "\nHealth: " .. player.health .. "\nLooking at: " 
	if tiles[currentLevel[selectedTile[1]][selectedTile[2]]].name then
		status = status .. tiles[currentLevel[selectedTile[1]][selectedTile[2]]].name .. ". "
	end
	if SelectedAnimal then
		status = status .. " there is a " .. SelectedAnimal.name .. " " .. SelectedAnimal.activity
	end
	if agriculture[selectedTile[1]][selectedTile[2]] then
		status = status .. 
		" [test:" .. agriculture[selectedTile[1]][selectedTile[2]] .. "]"
	end
	if StatusMessage then
		status = status .. StatusMessage
	end
	
	love.graphics.printf(status,10,420,580,"left")
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill",0,0,800,30)
	love.graphics.setColor(255,255,255)
	love.graphics.rectangle("line",0,0,800,30)
	love.graphics.printf(shownHour .. ":" .. shownMinute .. ", " ..
	datenames[shownDay] .. "dag of " ..  
	months[shownMonth] .. ", year of the " .. 
	datenames[(shownYear + 10) % 15 + 1] .. 
	datenames[(shownYear + 14) % 15 + 1],0,10,800,"center")
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill",610,410,185,185)
	love.graphics.setColor(255,255,255)
	
	love.graphics.setColor(255,255,255)
	tempXscale = 200 / Map:getWidth()
	tempYscale = 200 / Map:getHeight()
	love.graphics.draw(Map,600,400,0,tempXscale,tempYscale)
	love.graphics.rectangle("line",600,400,200,200)
	--love.graphics.setColor(255,0,0)
	--love.graphics.rectangle("fill",(player.x * tempXscale) - 1 + 625,(player.y * 0.2) - 1 + 425,3,3)
end